import type { Effect } from './effect';
export default class EffectManager {
    effects: Effect[];
    private _resolvedEffects;
    /** Effect instances and order preference pairs, sorted by order */
    private _defaultEffects;
    private _needsRedraw;
    constructor();
    /**
     * Register a new default effect, i.e. an effect presents regardless of user supplied props.effects
     */
    addDefaultEffect(effect: Effect): void;
    setProps(props: any): void;
    needsRedraw(opts?: {
        clearRedrawFlags: boolean;
    }): false | string;
    getEffects(): Effect[];
    private _setEffects;
    finalize(): void;
}
//# sourceMappingURL=effect-manager.d.ts.map