import type { Widget, WidgetPlacement } from './widget-manager';
import type { PickingInfo } from './picking/pick-info';
import type Viewport from '../viewports/viewport';
import type Deck from './deck';
export declare type TooltipContent = null | string | {
    text?: string;
    html?: string;
    className?: string;
    style?: Partial<CSSStyleDeclaration>;
};
export default class Tooltip implements Widget {
    id: string;
    placement: WidgetPlacement;
    props: {};
    isVisible: boolean;
    deck?: Deck;
    element?: HTMLDivElement;
    lastViewport?: Viewport;
    onAdd({ deck }: {
        deck: Deck;
    }): HTMLDivElement;
    onRemove(): void;
    setProps(): void;
    onViewportChange(viewport: Viewport): void;
    onHover(info: PickingInfo): void;
    setTooltip(displayInfo: TooltipContent, x?: number, y?: number): void;
}
//# sourceMappingURL=tooltip.d.ts.map